/*  Name:
 *  PennKey:
 *  Execution: N/A, this class is meant to be used by other classes
 *
 *  A class that represents the Fish projectile in
 *  Furious Flying Fish. Can update its own position based
 *  on velocity and time, and can compute whether
 *  it overlaps a given Target.
 *
 */

public class Fish {
    // The position, velocity, and radius members of the Fish.
    private double xPos, yPos, xVel, yVel, radius;

    /**
     * How many more times the player can throw the Fish
     * before losing the game.
     */
    private int numThrowsRemaining;

    /**
     * Initialize the Fish's member variables
     * with the same names as the inputs to those values.
     * Initializes the Fish's velocity components to 0.
     */
    public Fish(double xPos, double yPos, double radius, int numThrowsRemaining) {
        // TODO
    }

    /**
     * Draws a Circle centered at the Fish's position
     * with a radius equal to the Fish's radius.
     * Additionally, draws a triangular beak and two
     * circular eyes somewhere on the circle to make
     * the Fish look more like a Fish. Additional details
     * are up to your discretion.
     * Also draws the Fish's remaining throws 0.1 units
     * above its circular body.
     */
    public void draw() {
        // TODO
    }

    /**
     * Draw the line representing the Fish's initial velocity
     * when the player is clicking and dragging the mouse.
     */
    public void drawVelocity() {
        // TODO
    }

    /**
     * Set xPos and yPos to 1.0,
     * set xVel and yVel to 0.0.
     */
    public void reset() {
        xPos = 1.0;
        yPos = 1.0;
        xVel = 0.0;
        yVel = 0.0;
    }

    /**
     * Compute the Fish's initial velocity as the
     * vector from the mouse's current position to
     * the Fish's current position. This will be used
     * in mouse listening mode to update the launch
     * velocity.
     */
    public void setVelocityFromMousePos() {
        // TODO
    }

    /**
     * Given the change in time, compute the Fish's
     * new position and new velocity.
     */
    public void update(double timeStep) {
        // TODO
    }

    /**
     * A helper function used to find the distance
     * between two 2D points. Remember to use the
     * Pythagorean Theorem.
     */
    private static double distance(double x1, double y1, double x2, double y2) {
        // TODO
        return 0.0;
    }

    /**
     * Given a Target, determine if the Fish should
     * test for collision against it. If the Fish
     * *should* see if it collides with the target,
     * then perform that test. If the Fish collides,
     * then decrease the target's HP by 1 set its
     * hitThisShot field to be true.
     */
    public void testAndHandleCollision(Target t) {
        // TODO
    }

    // Reduce numThrowsRemaining by 1.
    public void decrementThrows() {
        // TODO
    }

    /**
     * Getter functions that return a copy
     * of the indicated member variable.
     */
    public double getXpos() {
        return xPos;
    }

    public double getYpos() {
        return yPos;
    }

    public double getRadius() {
        return radius;
    }

    public int getNumThrowsRemaining() {
        return numThrowsRemaining;
    }
}
